/*
 * Atari ST hardware:
 * Address map
 */

#define	AD_RAM		0x000000	/* main memory */
#define	AD_CART		0xFA0000	/* expansion cartridge */
#define	AD_ROM		0xFC0000	/* system ROM */
#define	AD_IO		0xFF8000	/* I/O devices */

/*
 * I/O address parts of 0x000200 each
 */
#define	AD_RAMCFG	0xFF8000	/* ram configuration */
#define	AD_VIDEO	0xFF8200	/* video controller */
/*	AD_RESERVED	0xFF8400	/* reserved */
#define	AD_DMA		0xFF8600	/* DMA device access */
#define	AD_SOUND	0xFF8800	/* YM-2149 */

#define	AD_MFP		0xFFFA00	/* 68901 */
#define	AD_ACIA		0xFFFC00	/* 2 * 6850 */
