/* File: pipes.c - created by Marty Leisner */
/* leisner.Henr         1-Dec-87  8:55:04 */

/* Copyright (C) 1987 by Martin Leisner. All rights reserved. */

#define BLOCK_SIZE 	1000
#define NUM_BLOCKS	1000
char buffer[BLOCK_SIZE];

main()
{
	int pipefd[2];
	register int i;
	pipe(&pipefd);
	
	
	
	switch(fork()) {
		case 0:
			/* child code */
			for(i = 0; i < NUM_BLOCKS; i++)
				if(read(pipefd[0], &buffer, BLOCK_SIZE) != BLOCK_SIZE)
					break;
				;
			printf("child done, i = %d\n", i);
			exit();
			break;
		case -1:
			perror("fork broke");
			exit();
		default:
			/* parent code */
			for(i = 0; i < NUM_BLOCKS; i++)
				write(pipefd[1], &buffer, BLOCK_SIZE);
				
			puts("parent done");
			wait((char *) 0);
			break;
	}
}
